blob: dc0e8c5a140239c6a3bb13ccfbca5ab522328a28 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
38 printf " %-7s %s\n" ${1} ${2}
39 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
Stephen Rothwella5967db2016-08-24 22:29:19 +100046 local objects
47
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100048 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090049 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100050 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
Masahiro Yamadad503ac52018-08-24 08:20:39 +090055 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020056}
57
58# Link of vmlinux
59# ${1} - optional extra .o files
60# ${2} - output file
61vmlinux_link()
62{
63 local lds="${objtree}/${KBUILD_LDS}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100064 local objects
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020065
66 if [ "${SRCARCH}" != "um" ]; then
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100067 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090068 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100069 --no-whole-archive \
70 --start-group \
71 ${KBUILD_VMLINUX_LIBS} \
72 --end-group \
73 ${1}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100074
Masahiro Yamadad503ac52018-08-24 08:20:39 +090075 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100076 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020077 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100078 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090079 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100080 -Wl,--no-whole-archive \
81 -Wl,--start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 -Wl,--end-group \
84 ${1}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100085
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100086 ${CC} ${CFLAGS_vmlinux} -o ${2} \
87 -Wl,-T,${lds} \
88 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100089 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020090 rm -f linux
91 fi
92}
93
94
95# Create ${2} .o file with all symbols from the ${1} object file
96kallsyms()
97{
98 info KSYM ${2}
99 local kallsymopt;
100
101 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100102 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200103 fi
104
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700105 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030106 kallsymopt="${kallsymopt} --absolute-percpu"
107 fi
108
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700109 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
110 kallsymopt="${kallsymopt} --base-relative"
111 fi
112
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200113 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
114 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200115
Ard Biesheuvela0439342016-02-05 11:25:05 +0100116 local afile="`basename ${2} .o`.S"
117
118 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
119 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200120}
121
122# Create map file with all symbols from ${1}
123# See mksymap for additional details
124mksysmap()
125{
126 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
127}
128
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700129sortextable()
130{
131 ${objtree}/scripts/sortextable ${1}
132}
133
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200134# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200135cleanup()
136{
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200137 rm -f .tmp_System.map
138 rm -f .tmp_kallsyms*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200139 rm -f .tmp_vmlinux*
140 rm -f System.map
141 rm -f vmlinux
142 rm -f vmlinux.o
143}
144
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000145on_exit()
146{
147 if [ $? -ne 0 ]; then
148 cleanup
149 fi
150}
151trap on_exit EXIT
152
153on_signals()
154{
155 exit 1
156}
157trap on_signals HUP INT QUIT TERM
158
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200159#
160#
161# Use "make V=1" to debug this script
162case "${KBUILD_VERBOSE}" in
163*1*)
164 set -x
165 ;;
166esac
167
168if [ "$1" = "clean" ]; then
169 cleanup
170 exit 0
171fi
172
173# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900174. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200175
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200176# Update version
177info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900178if [ -r .version ]; then
179 VERSION=$(expr 0$(cat .version) + 1)
180 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200181else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900182 rm -f .version
183 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200184fi;
185
186# final build of init/
Cao jina7b151f2018-02-21 12:25:07 +0800187${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200188
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100189#link vmlinux.o
190info LD vmlinux.o
191modpost_link vmlinux.o
192
193# modpost vmlinux.o to check for section mismatches
194${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
195
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200196kallsymso=""
197kallsyms_vmlinux=""
198if [ -n "${CONFIG_KALLSYMS}" ]; then
199
200 # kallsyms support
201 # Generate section listing all symbols and add it into vmlinux
202 # It's a three step process:
203 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
204 # but __kallsyms is empty.
205 # Running kallsyms on that gives us .tmp_kallsyms1.o with
206 # the right size
207 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
208 # the right size, but due to the added section, some
209 # addresses have shifted.
210 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100211 # 3) That link may have expanded the kernel image enough that
212 # more linker branch stubs / trampolines had to be added, which
213 # introduces new names, which further expands kallsyms. Do another
214 # pass if that is the case. In theory it's possible this results
215 # in even more stubs, but unlikely.
216 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
217 # other bugs.
218 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200219 #
220 # a) Verify that the System.map from vmlinux matches the map from
221 # ${kallsymso}.
222
223 kallsymso=.tmp_kallsyms2.o
224 kallsyms_vmlinux=.tmp_vmlinux2
225
226 # step 1
227 vmlinux_link "" .tmp_vmlinux1
228 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
229
230 # step 2
231 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
232 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
233
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100234 # step 3
Michael Forneya670b0b2018-03-18 17:54:02 -0700235 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
236 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100237
238 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200239 kallsymso=.tmp_kallsyms3.o
240 kallsyms_vmlinux=.tmp_vmlinux3
241
242 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
243
244 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
245 fi
246fi
247
248info LD vmlinux
249vmlinux_link "${kallsymso}" vmlinux
250
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700251if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
252 info SORTEX vmlinux
253 sortextable vmlinux
254fi
255
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200256info SYSMAP System.map
257mksysmap vmlinux System.map
258
259# step a (see comment above)
260if [ -n "${CONFIG_KALLSYMS}" ]; then
261 mksysmap ${kallsyms_vmlinux} .tmp_System.map
262
263 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200264 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200265 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200266 exit 1
267 fi
268fi